package cz.zweistein.gw.predictor;

import java.util.LinkedList;
import java.util.List;

import org.apache.log4j.Logger;

import cz.zweistein.gw.predictor.controller.ConfigurationLoader;
import cz.zweistein.gw.predictor.controller.ConfigurationLoaderImpl;
import cz.zweistein.gw.predictor.model.Configuration;
import cz.zweistein.gw.predictor.model.User;

public class Predictor {
	private static Logger logger = Logger.getLogger(Predictor.class);

	public static void main(String[] args) throws Exception {
		
		logger.info("Xunlai tournament Vote v 0.2b");
		logger.info("[z] Zweistein 2009");
		
		ConfigurationLoader configurationLoader = new ConfigurationLoaderImpl();
		Configuration config = configurationLoader.loadConfiguration();
		XTHRemote xth = new XTHRemote();
		
		for (User user : config.getUsers()) {
			xth.logIn(user);
			
			if (xth.isLoggedIn()) {
				
				logger.info("Voting for:" + user.getEmail());
				
				Guilds qualifiedGuilds = new Guilds(xth);
				List<Guild> preparedGuildVotes = new LinkedList<Guild>();
				for (String guildName : config.getVotedGuild()) {
					Guild guild = qualifiedGuilds.getGuildForName(guildName);
					preparedGuildVotes.add(guild);
				}
				xth.voteForGvG(preparedGuildVotes);
				
				Players qualifiedPlayers = new Players(xth);
				List<Player> preparedPlayerVotes = new LinkedList<Player>();
				for (String playerName : config.getVotedPlayer()) {
					Player player = qualifiedPlayers.gePlayerForName(playerName);
					preparedPlayerVotes.add(player);
				}
				xth.voteFor1v1(preparedPlayerVotes);
				
				logger.info("Done for " + user.getEmail());
			}
		}
		
	}

}
