package cz.zweistein.gw.predictor.controller;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.apache.log4j.Logger;

import cz.zweistein.gw.predictor.model.Configuration;
import cz.zweistein.gw.predictor.model.User;

public class ConfigurationLoaderImpl implements ConfigurationLoader {
	private static Logger logger = Logger.getLogger(ConfigurationLoaderImpl.class);

	public Configuration loadConfiguration() throws IOException {
		//evil, hardcoded stuff.
		
		Configuration config = new Configuration();
		
		config.setUsers(this.loadUsers());
		config.setVotedGuild(this.loadGuilds());
		config.setVotedPlayer(this.loadPlayers());

		return config;
	}

	private List<User> loadUsers() throws IOException {
		logger.info("Loading user config");
		
		File usersFile = new File("users.cfg");
		
		FileReader usersFileReader = new FileReader(usersFile);
		BufferedReader bufferedUsersFileReader = new BufferedReader(
				usersFileReader);

		String unparsedUser = bufferedUsersFileReader.readLine();
		
		List<User> users = new LinkedList<User>();
		
		while (unparsedUser != null) {
			String[] parsedUser = unparsedUser.split(" ");
			
			if (parsedUser.length != 1) {
				User user = new User();
				user.setEmail(parsedUser[0]);
				user.setPassword(parsedUser[1]);
				users.add(user);
				logger.info("User " + user + " registered for voting");
			} else {
				logger.warn("Something is weird with this line of config: \"" + unparsedUser + "\", ignoring." );
			}
			
			unparsedUser = bufferedUsersFileReader.readLine();
		}
		
		logger.info(users.size() + " users loaded.");
		
		return users;
	}
	
	private List<String> loadGuilds() throws IOException {
		logger.info("Loading gvg config");
		
		File guildsFile = new File("gvg.cfg");
		
		FileReader usersFileReader = new FileReader(guildsFile);
		BufferedReader bufferedGuildsFileReader = new BufferedReader(
				usersFileReader);

		String guild = bufferedGuildsFileReader.readLine();
		
		List<String> guilds = new ArrayList<String>(8);
		
		while (guild != null) {
			
			guilds.add(guild.trim());
			
			logger.info("Guild " + guild + " loaded as #" + guilds.size());
			
			guild = bufferedGuildsFileReader.readLine();
		}
		
		logger.info(guilds.size() + " predictions loaded.");
		
		return guilds;
	}
	
	private List<String> loadPlayers() throws IOException {
		logger.info("Loading 1v1 config");

		File playersFile = new File("1v1.cfg");
		
		FileReader usersFileReader = new FileReader(playersFile);
		BufferedReader bufferedPlayersFileReader = new BufferedReader(
				usersFileReader);

		String player = bufferedPlayersFileReader.readLine();
		
		List<String> players = new ArrayList<String>(8);
		
		while (player != null) {
			
			players.add(player.trim());
			
			logger.info("#" + players.size()+ " " + player);
			
			player = bufferedPlayersFileReader.readLine();
		}
		
		logger.info(players.size() + " predictions loaded.");
		
		return players;
	}
	
}
